<?php

namespace App\Http\Controllers;

use App\Models\AccionLog;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class AccionLogController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = AccionLog::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new AccionLog())->getFillable());
        $accionLog = AccionLog::create($payload);

        return response()->json([
            'success' => true,
            'data' => $accionLog,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(AccionLog $accionLog): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $accionLog,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, AccionLog $accionLog): JsonResponse
    {
        $payload = $request->only((new AccionLog())->getFillable());
        $accionLog->update($payload);

        return response()->json([
            'success' => true,
            'data' => $accionLog,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(AccionLog $accionLog): JsonResponse
    {
        $accionLog->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}